#! /usr/bin/python
# -*- python -*-

# My own HTTP server for the IPP

import cgi, os, sys, time, socket, string, posixpath, SocketServer, \
       BaseHTTPServer, ipp
from httplib import HTTP

class MyHTTPRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):

    def ipp_deal(self):
	# reads OK or cancel from consumer's browser.
	# the tnxid and the choice keys are after the ? in self.path.

	keys = cgi.parse_qs(self.path[string.find(self.path, "?") + 1:])

	if not keys.has_key("tnxid") or not keys.has_key("choice"):
	    print "ERROR: Couldn't find keys in form data"
	    self.wfile.write("<html><body>")
	    self.wfile.write("<p> ERROR: Couldn't find keys in"
			     "form data.")
	    self.wfile.write("</body></html>")	    
	    return

	tnxid = keys["tnxid"][0]
	choice = keys["choice"][0]
	
	# How do we know it's the correct consumer with this trans-id? Do
	# we care?

	# Contact seller-deal.cgi and tell them about the choice.
    
	h = HTTP("localhost", 4000)

	url = "/seller-deal.cgi?tnxid=%s&choice=%s" \
	      % (tnxid, choice)
	h.putrequest("GET", url)
	h.putheader("Accept", "text/html")
	h.putheader("Accept", "text/plain")
	h.endheaders()
	errcode, errmsg, headers = h.getreply()
	if errcode == 200:
	    # Parse the response from seller. It can be "OK" or "ERROR".
	    response = string.strip(h.getfile().read())
	    self.wfile.write("<html><body>")
	    if response == "OK":
		# Write OK to consumer.

		if choice == "OK":
		    self.wfile.write("<h1>Order Filed</h1>")
		    self.wfile.write("<p> Filed order with seller.")
		else:
		    self.wfile.write("<h1>Order Cancelled</h1>")
		    self.wfile.write("<p> Cancelled order with seller.")
	    else:
		# Local error at seller.
		self.wfile.write("<h1>Errror</h1>")
		self.wfile.write("<p> Local error at seller. Can't continue "
				 "with transaction.")

	    # In either case:
	    # FIXME: Delete the transaction data.
	    self.wfile.write("</html></body>")
	else:
	    # Something went terribly wrong, error code != 200.
	    self.wfile.write("<html><body>")
	    self.wfile.write("<h1>Error</h1>")
	    self.wfile.write("<p> Couldn't contact seller.")
	    self.wfile.write("</html></body>")

    def ipp_approval(self):
	# reads a transaction ID from GET
	# the tnxid is after the ? in self.path.

	order = ipp.paymentorder()
	
	tnxindex = string.find(self.path, "tnxid=")
	if tnxindex == -1:
	    print "ERROR: Couldn't find transaction ID"
	    self.wfile.write("<html><body>")
	    self.wfile.write("<p> ERROR: Couldn't find the transaction ID."
			     "Contact the seller personel.")
	    self.wfile.write("</body></html>")	    
	    return

	tnxid = self.path[tnxindex + len("tnxid="):]

	# find tnxid in database

	try:
	    order.fetch(tnxid)
	except KeyError:
	    print "ERROR: Couldn't find", tnxid, " in " \
		  "database."
	else:
	    # present the items to the consumer and a form,
	    # with OK and cancel.

	    self.wfile.write("<html><body>")
	    self.wfile.write("<pre>")
    
	    for key in order.paydata.keys():
		self.wfile.write(order.paydata[key])
    
	    self.wfile.write("</pre>")
	    self.wfile.write("<p> Do you agree to this transaction?")
	    self.wfile.write("<form action=\"http://localhost:8000/"
			     "ipp-deal.cgi\" method=\"get\">")
	    self.wfile.write("<input type=hidden name=tnxid value=%s>" \
			     % (order.paydata["tnxid"]))
	    self.wfile.write("<input type=submit name=choice "
			     "value=\"OK\">")
	    self.wfile.write("<input type=submit name=choice "
			     "value=\"Cancel\">")
	    self.wfile.write("</form></body></html>")
	    
    def ipp_order(self):
	order = ipp.paymentorder()

	if not order.read():
	    self.wfile.write("ERROR: Couldn't find order in POST data.")
	else:
	    # generate a unique (not really) transaction ID

	    order.paydata["tnxid"] = "foo"

	    # store the data relating to this transaction.

	    order.store()
    
	    # write back the transaction ID to the seller.

	    self.wfile.write(order.paydata["tnxid"])

    def do_GET(self):
        """Serve a GET request."""
	self.send_response(200)

	# What CGI are they asking for?

	if self.path[:14] == "/ipp-order.cgi":
	    self.send_header("Content-type", "text/plain")
	    self.end_headers()
	    self.ipp_order()
	elif self.path[:17] == "/ipp-approval.cgi":
	    self.send_header("Content-type", "text/html")
	    self.end_headers()
	    self.ipp_approval()
	elif self.path[:13] == "/ipp-deal.cgi":
	    self.send_header("Content-type", "text/html")
	    self.end_headers()
	    self.ipp_deal()

def test(HandlerClass = MyHTTPRequestHandler,
         ServerClass = BaseHTTPServer.HTTPServer):
    """Test the HTTP request handler class.

    This runs an HTTP server on port 8000 (or the first command line
    argument).

    """

    if sys.argv[1:]:
        port = string.atoi(sys.argv[1])
    else:
        port = 8000
    server_address = ('', port)

    httpd = ServerClass(server_address, HandlerClass)

    print "Serving HTTP on port", port, "..."
    httpd.serve_forever()

if __name__ == '__main__':
    test()
