import anydbm, cgi, cPickle

class paymentorder:
    """
    Methods to read a payment order from POST data, store and fetch it
    from a database.
    """

    def __init__(self):
	self.empty()				     # Initialize variables

    def empty(self):
	"Set 'private' variables to nul"

	self.paydata = {"buyer": "",
		       "seller": "",
		       "amount": "",
		       "currency": "",
		       "flags": "",
		       "contract": "",
		       "external": "",
		       "tnxid": ""}

	self.dbfile = "/tmp/ippdata.dbm"
	self.debug = 0

    def read(self):
	"Read a payment order from POST data"

	self.form = cgi.FieldStorage()               # Read the POST data
	if self.debug:
	    print "CGI fields:", self.form

	# Read in all the keys from the form. Don't mind if we do read
	# in a bogus tnxid. It doesn't matter. It depens on what
	# higher levels expect from us.

	if self.debug:
	    print "self.paydata.keys are", self.paydata.keys()
	for key in self.paydata.keys():
	    if self.form.has_key(key):
		self.paydata[key] = self.form[key].value
	    if self.debug == 1:
		print "key %s: %s" % (key, self.paydata[key])

	return -1
    
    def store(self):
	"Store data covering a complete transaction to the database."

	db = anydbm.open(self.dbfile, "c")
	db[self.paydata["tnxid"]] = cPickle.dumps(self.paydata, 1)
	db.close()
	
    def fetch(self, tnxid):
	"Fetch data for a specific transaction ID."

	db = anydbm.open(self.dbfile, "r")
	self.paydata = cPickle.loads(db[tnxid])
	db.close()
