#! /usr/bin/python
# -*- python -*-

# My own HTTP server for the Seller side of things.

import cgi, os, sys, time, socket, string, posixpath, SocketServer, \
       BaseHTTPServer, seller
from httplib import HTTP

class MyHTTPRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):

    orderurl = "/seller-order.cgi"
    dealurl = "/seller-deal.cgi"

    def seller_order(self):
	#print "seller_order() called"

	order = seller.paymentorder()

	tnxid = order.send("localhost:8000/ipp-order.cgi")

	if tnxid == None:
	    self.wfile.write("<p> Can't get tnxid from ipp-order.cgi")
	else:
	    self.wfile.write("<p> Submit this form to get to your Internet "
			     "Payment Provider.")
	    self.wfile.write("<form action=\"http://localhost:8000/ipp-approval.cgi\" method=\"get\">")
	    self.wfile.write("<input type=hidden name=tnxid value=\"%s\">"
			     % (tnxid))
	    self.wfile.write("<p> <input type=submit value=\"Submit order\">")

	# In either case:

	self.wfile.write("</form></body></html>")

    def seller_deal(self):
	# Reads OK or Cancel and tnxid from IPP

	keys = cgi.parse_qs(self.path[string.find(self.path, "?") + 1:])

	if not keys.has_key("tnxid") or not keys.has_key("choice"):
	    print "ERROR: Couldn't find keys in form data"
	    self.wfile.write("ERROR")
	    return

	tnxid = keys["tnxid"][0]
	choice = keys["choice"][0]

	# File the order locally to be handled later.

	# Send OK back to IPP

	self.wfile.write("OK")
	
    def do_GET(self):
        """Serve a GET request."""
	
	# What CGI are they asking for?

	if self.path[:len(self.orderurl)] == self.orderurl:
	    self.send_response(200)
	    self.send_header("Content-type", "text/html")
	    self.end_headers()
	    self.seller_order()
	elif self.path[:len(self.dealurl)] == self.dealurl:
	    self.send_response(200)
	    self.send_header("Content-type", "text/plain")
	    self.end_headers()
	    self.seller_deal()
	else:
	    self.send_response(404)
	    self.send_header("Content-type", "text/html")
	    self.end_headers()
	    self.wfile.write("<p> No such file")


def test(HandlerClass = MyHTTPRequestHandler,
         ServerClass = BaseHTTPServer.HTTPServer):
    """Test the HTTP request handler class.

    This runs an HTTP server on port 4000 (or the first command line
    argument).

    """

    if sys.argv[1:]:
        port = string.atoi(sys.argv[1])
    else:
        port = 4000
    server_address = ('', port)

    httpd = ServerClass(server_address, HandlerClass)

    print "Serving HTTP on port", port, "..."
    httpd.serve_forever()

if __name__ == '__main__':
    test()
