#
# Class for payee.
#

import anydbm, cgi, cPickle, socket, string
from httplib import HTTP

class paymentorder:
    """
    Methods to read a payment order from POST data, send it on to an
    Internet Payment Provide for processing and methods for storing
    and fetching it from a local database in self.dbfile.
    """

    def __init__(self):
	self.empty()				     # Initialize variables

    def empty(self):
	"Set 'private' variables to nul"

	self.paydata = {"buyer": "",
		       "seller": "",
		       "amount": "",
		       "currency": "",
		       "flags": "",
		       "contract": "",
		       "external": "",
		       "tnxid": ""}

	self.dbfile = "/home/mc/private/relogic/e-commerce/src/ec2000-cgi/sellerdata.dbm"
	self.debug = 0

    def read(self):
	"Read a payment order from POST data"

	self.form = cgi.FieldStorage()               # Read the POST data
	
	# Read in all the keys from the form. Don't mind if we do read
	# in a bogus tnxid. It doesn't matter. It depens on what
	# higher levels expect from us.
	
	for key in self.paydata.keys():
	    if self.form.has_key(key):
		self.paydata[key] = self.form[key].value

	    if self.debug == 1:
		for key in self.paydata.keys():
		    print self.paydata[key]
	    return -1

    def store(self):
	"Store data covering a complete transaction to the database."

	db = anydbm.open(self.dbfile, "c")
	db[self.paydata["tnxid"]] = cPickle.dumps(self.paydata, 1)
	db.close()
	
    def fetch(self, tnxid):
	"Fetch data for a specific transaction ID."

	db = anydbm.open(self.dbfile, "r")
	self.paydata = cPickle.loads(db[tnxid])
	db.close()

    def send(self, ippaddress):
	"Send payment order to IPP"

	h = HTTP("localhost", 8000)

	url = "/ipp-order.cgi"
	h.putrequest("GET", url)
	h.putheader("Accept", "text/html")
	h.putheader("Accept", "text/plain")
	h.endheaders()
	errcode, errmsg, headers = h.getreply()
	if errcode == 200:
	    # Read the transaction ID that comes back. Strip all
	    # whitespace.

	    tnxid = string.strip(h.getfile().read())
	    return tnxid
	else:
	    # Report some error.
	    return None
